import defer from "lodash/defer";
var _replaying = false;
var _monitor = null;
export var flagReplaying = function (state) { return _replaying = state; };
export var setMonitor = function (monitor) { _monitor = monitor; };
export var isReplaying = function () {
    return _replaying || _monitor && _monitor.isTimeTraveling();
};
export var dispatch = function (_) {
    return function (next) {
        return function (action) {
            var syncActivityFinished = false;
            var actionQueue = [];
            var withDispatch = function (action) {
                return Object.assign({}, action, { dispatchFromUpdate: dispatchFromUpdate });
            };
            function flushQueue() {
                actionQueue = actionQueue.reduce(function (nextActionQueue, currentAction) {
                    next(currentAction);
                    return nextActionQueue.slice(1);
                }, actionQueue);
            }
            function dispatchFromUpdate(action) {
                if (!isReplaying())
                    actionQueue.push(withDispatch(action));
                if (syncActivityFinished)
                    defer(function () { return flushQueue(); });
            }
            var actionWithDispatch = withDispatch(action);
            next(actionWithDispatch);
            syncActivityFinished = true;
            flushQueue();
            return actionWithDispatch;
        };
    };
};
//# sourceMappingURL=dispatchMiddleware.js.map