var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import * as ReactDOM from "react-dom";
import { createStore, applyMiddleware, compose } from "redux";
import { Provider, connect } from "react-redux";
import { AppContainer } from "react-hot-loader";
import { dispatch, flagReplaying, setMonitor, isReplaying } from "./dispatchMiddleware";
import * as Router from "./router";
import EditableText from "./EditableText";
import defer from "lodash/defer";
import List from "./list";
import moize from "moize";
export { React, EditableText, List, moize };
export var lift = function (dispatch, props) {
    return function (action, e) {
        return dispatch(__assign({}, action, props), e);
    };
};
var Component = (function (_super) {
    __extends(Component, _super);
    function Component(props) {
        var _this = _super.call(this, props) || this;
        _this.dispatch = _this.dispatch.bind(_this);
        return _this;
    }
    Component.prototype.dispatch = function (action, eventToStop) {
        if (eventToStop)
            eventToStop.stopPropagation();
        return this.props.dispatch(action);
    };
    return Component;
}(React.PureComponent));
export { Component };
export var ActionType;
(function (ActionType) {
    ActionType["Init"] = "ReactiveElm/Init";
})(ActionType || (ActionType = {}));
export var InitType = ActionType.Init;
export var init = {
    type: "ReactiveElm/Init"
};
export var GotoType = Router.ActionType.Goto;
export var goto = Router.goto;
var store;
export var load = function (initialState, reactsTo, update, RootJSXElement, routeToUri, uriToRoute, module, baseUri, rootHTMLElement) {
    if (baseUri === void 0) { baseUri = ""; }
    if (rootHTMLElement === void 0) { rootHTMLElement = document.body.firstElementChild; }
    var wrappedUpdate = function (state, action) {
        if (isReplaying() && action.noReplay)
            return state;
        var newState = state;
        if (Router.reactsTo(action)) {
            newState = Router.update(state, action, routeToUri, baseUri);
        }
        if (reactsTo(action)) {
            newState = update(newState, action, action.dispatchFromUpdate);
        }
        return newState;
    };
    var composeEnhancers = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ ?
        window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__({
            getMonitor: function (monitor) { setMonitor(monitor); }
        }) :
        compose;
    var isHotReloading = store ? true : false;
    if (isHotReloading) {
        flagReplaying(true);
        store.replaceReducer(wrappedUpdate);
        defer(function () { return flagReplaying(false); });
    }
    else {
        store = createStore(wrappedUpdate, initialState, composeEnhancers(applyMiddleware(dispatch)));
    }
    var Index = (function (_super) {
        __extends(Index, _super);
        function Index(state) {
            var _this = _super.call(this, state) || this;
            if (typeof window.__REACT_HOT_LOADER__ !== "undefined") {
                window.__REACT_HOT_LOADER__.warnings = false;
            }
            return _this;
        }
        Index.prototype.componentWillMount = function () {
            this.unloadRouter = Router.load(this.props.dispatch, uriToRoute, baseUri, isHotReloading);
            if (!isHotReloading)
                this.props.dispatch(init);
        };
        Index.prototype.componentWillUnmount = function () {
            this.unloadRouter();
        };
        Index.prototype.render = function () {
            var Elem = RootJSXElement;
            return React.createElement(Elem, __assign({}, this.props, { dispatch: this.dispatch }));
        };
        return Index;
    }(Component));
    var View = connect(function (s) { return s; })(Index);
    ReactDOM.render(React.createElement(AppContainer, null,
        React.createElement(Provider, { store: store },
            React.createElement(View, null))), rootHTMLElement);
    var mod = module;
    if (mod.hot)
        mod.hot.accept();
};
export var withDispatch = function (f) {
    return function (state, action) { return f(state, action, function (a) { return a; }); };
};
export var exists = function (it) {
    return it !== undefined && it !== null;
};
export function log(value) {
    var others = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        others[_i - 1] = arguments[_i];
    }
    console.log.apply(console, others.concat(value));
    return value;
}
//# sourceMappingURL=index.js.map