import map from "lodash/map";
import find from "lodash/find";
var propsMatch = function (a, b) {
    for (var key in b) {
        if (b[key] !== a[key]) {
            return false;
        }
    }
    return true;
};
var getNewValue = function (newValue, oldValue) {
    return typeof newValue === "function" ? newValue(oldValue) : newValue;
};
var set = function (list, where, value) {
    return map(list, function (item, i) {
        return (typeof where === "number" ? where === i : propsMatch(item, where)) ?
            getNewValue(value, item) :
            item;
    });
};
var get = function (list, where) {
    return find(list, function (item) { return propsMatch(item, where); });
};
var reverse = function (list) { return list.slice().reverse(); };
var contains = function (list, item) {
    return list.findIndex(function (x) { return x === item; }) >= 0;
};
var List = { set: set, get: get, reverse: reverse, contains: contains };
export default List;
//# sourceMappingURL=list.js.map