import * as Redux from "redux";
export declare type UriToRoute<Route> = (uri: string) => Route;
export declare type RouteToUri<Route> = (route: Route) => string;
export declare const load: <Route>(dispatch: Redux.Dispatch<Redux.Action>, uriToRoute: UriToRoute<Route>, baseUri?: string, isHotReloading?: boolean) => () => void;
export interface State<Route> {
    route: Route;
}
export declare type Action<Route> = Goto<Route>;
export declare enum ActionType {
    Goto = "Goto",
}
export declare const reactsTo: <Route>(action: Redux.Action) => action is Goto<Route>;
export interface GotoOpts {
    viaHistory?: boolean;
    noBack?: boolean;
}
export interface Goto<Route> {
    type: ActionType.Goto;
    route: Route;
    opts: GotoOpts;
}
export declare const goto: <Route>(route: Route, opts?: GotoOpts) => Goto<Route>;
export declare const update: <Route>(state: State<Route>, action: Goto<Route>, routeToUri: RouteToUri<Route>, baseUri?: string) => State<Route>;
