var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import createHistory from "history/createBrowserHistory";
var history = createHistory();
var getPath = function (baseUri) {
    if (baseUri === void 0) { baseUri = ""; }
    if (baseUri)
        baseUri += "/";
    return window.location.pathname.slice(1).split("").reduce(function (result, char, i) {
        return result + (char === baseUri[i] ? "" : char);
    }, "");
};
export var load = function (dispatch, uriToRoute, baseUri, isHotReloading) {
    if (baseUri === void 0) { baseUri = ""; }
    if (isHotReloading === void 0) { isHotReloading = false; }
    if (!isHotReloading)
        dispatch(goto(uriToRoute(getPath(baseUri)), { viaHistory: true }));
    return history.listen(function (_, action) {
        if (action === "POP")
            dispatch(goto(uriToRoute(getPath(baseUri)), { viaHistory: true }));
    });
};
export var ActionType;
(function (ActionType) {
    ActionType["Goto"] = "Goto";
})(ActionType || (ActionType = {}));
export var reactsTo = function (action) {
    switch (action.type) {
        case ActionType.Goto:
            return true;
        default: return false;
    }
};
export var goto = function (route, opts) {
    if (opts === void 0) { opts = {}; }
    return ({
        type: ActionType.Goto,
        route: route,
        opts: opts
    });
};
export var update = function (state, action, routeToUri, baseUri) {
    if (baseUri === void 0) { baseUri = ""; }
    switch (action.type) {
        case ActionType.Goto:
            if (!action.opts.viaHistory) {
                var historyAction = action.opts.noBack ?
                    history.replace : history.push;
                historyAction("/" +
                    (baseUri ? baseUri + "/" : "") +
                    routeToUri(action.route));
            }
            return __assign({}, state, { route: action.route });
    }
};
//# sourceMappingURL=router.js.map